DEFINT A-Z

CONST cstTrue = -1, cstFALSE = 0

'$INCLUDE: 'is.bi'
'$INCLUDE: 'label.bi'
'$INCLUDE: 'const.bi'

'#############################################################################
'#                                                                           #
'#############################################################################
FUNCTION is.alpha.numeric (strSource AS STRING)

    DIM intIndex  AS INTEGER
    DIM intLength AS INTEGER
    DIM strChar   AS STRING

          strChar = MID$(strSource, 1, 1)
        intLength = LEN(strSource)
            IF intLength = 0 THEN
                is.alpha.numeric = cstFALSE
                EXIT FUNCTION
            END IF

    SELECT CASE strChar

        CASE "a" TO "z", "A" TO "Z", "_"
        CASE ELSE
             is.alpha.numeric = cstFALSE
             EXIT FUNCTION

    END SELECT

    FOR intIndex = 2 TO intLength
        strChar = MID$(strSource, intIndex, 1)

            SELECT CASE strChar
               
                CASE "a" TO "z", "A" TO "Z", "0" TO "9", "_", "."
                CASE ELSE
                     is.alpha.numeric = cstFALSE
                     EXIT FUNCTION

            END SELECT
   
    NEXT intIndex

    is.alpha.numeric = cstTrue

END FUNCTION

FUNCTION is.delim (strSource AS STRING)

    SELECT CASE strSource

        CASE "!", "@", "#", "$", "%", "^", "&", "*", "(", ")", "-", "+"
        CASE "[", "]", "{", "}", "\", "|", ";", ":", "<", ">", ",", "."
        CASE "/", "?", "~", "`"

        CASE ELSE
             is.delim = cstFALSE
             EXIT FUNCTION

    END SELECT

    is.delim = cstTrue

END FUNCTION

'#############################################################################
'#                                                                           #
'#############################################################################
FUNCTION is.immediate (strSource AS STRING)

    IF is.string(strSource) = cstImmediateString THEN
        is.immediate = cstImmediateString
        EXIT FUNCTION
    END IF

    IF is.long(strSource) = cstImmediateLong THEN
        is.immediate = cstImmediateLong
        EXIT FUNCTION
    END IF
   
    IF is.integer(strSource) = cstImmediateInteger THEN
        is.immediate = cstImmediateInteger
        EXIT FUNCTION
    END IF

END FUNCTION

FUNCTION is.integer (strSource AS STRING)

DIM intIndex      AS INTEGER
DIM intLength     AS INTEGER

    intLength = LEN(strSource)

    IF intLength > 6 THEN
        is.integer = cstFALSE
        EXIT FUNCTION
    END IF

'-----------------------------------------------------------------------------
'   Break strSource into individual numbers 1s, 10s, 100s, 1000s, etc.
'-----------------------------------------------------------------------------

DIM lngNumber(5) AS LONG

    FOR intIndex = intLength TO 1 STEP -1
        lngNumber(intIndex) = ASC(MID$(strSource, intLength - intIndex + 1, 1)) - 48
    NEXT intIndex

'-----------------------------------------------------------------------------
'   Multiply individual numbers by 1, 10, 100, 1000, etc.
'-----------------------------------------------------------------------------

      lngNumber(1) = lngNumber(1) * 1
      lngNumber(2) = lngNumber(2) * 10
      lngNumber(3) = lngNumber(3) * 100
      lngNumber(4) = lngNumber(4) * 1000
      lngNumber(5) = lngNumber(5) * 10000

'-----------------------------------------------------------------------------
'   Add up all of the individual numbers and place result in lngResult
'-----------------------------------------------------------------------------

DIM lngResult AS LONG

    FOR intIndex = intLength TO 1 STEP -1
        lngResult = lngResult + lngNumber(intIndex)
    NEXT intIndex


'-----------------------------------------------------------------------------
'   identify immediate data-type: integer, long, unsigned integer, or,
'                                 unsigned long
'-----------------------------------------------------------------------------

    SELECT CASE lngResult

        CASE -32768 TO 32767
             is.integer = cstImmediateInteger
             EXIT FUNCTION
       
        'Add support for unsinged integer detection.

    END SELECT

END FUNCTION

'#############################################################################
'#                                                                           #
'#############################################################################
FUNCTION is.keyword (strSource AS STRING)

    SELECT CASE LCASE$(strSource)

        CASE "asm"
        CASE "call"
        CASE "case"
        CASE "const"
        CASE "dec"
        CASE "declare"
        CASE "dim"
        CASE "do"
        CASE "else"
        CASE "end"
        CASE "exit"
        CASE "for"
        CASE "function"
        CASE "goto"
        CASE "if"
        CASE "inc"
        CASE "let"
        CASE "loop"
        CASE "next"
        CASE "return"
        CASE "select"
        CASE "sub"
        CASE "type"
        CASE ELSE
             is.keyword = cstFALSE
             EXIT FUNCTION
      
    END SELECT

    is.keyword = cstTrue

END FUNCTION

'#############################################################################
'#                                                                           #
'#############################################################################
FUNCTION is.line.label (strSource AS STRING)

    DIM intLength AS INTEGER
    DIM strTemp   AS STRING

          strTemp = MID$(strSource, 1, intLength - 1)
        intLength = LEN(strSource)          '#################################
            IF intLength <= 1 THEN          '# Line label must be at least 2 #
                is.line.label = cstFALSE    '# characters in total length.   #
                EXIT FUNCTION               '#################################
            END IF

    IF is.alpha.numeric(strTemp) = cstFALSE THEN
       is.line.label = cstFALSE
       EXIT FUNCTION
    END IF

          strTemp = RIGHT$(strSource, 1)

    IF strTemp <> ":" THEN
       is.line.label = cstFALSE
       EXIT FUNCTION
    END IF

    is.line.label = cstTrue

END FUNCTION

FUNCTION is.long (strSource AS STRING)

DIM intIndex      AS INTEGER
DIM intLength     AS INTEGER

    intLength = LEN(strSource)

    IF intLength < 6 THEN
        IF is.integer(strSource) <> cstFALSE THEN
            is.long = cstFALSE
            EXIT FUNCTION
        END IF
    END IF

'-----------------------------------------------------------------------------
'   Break strSource into individual numbers 1s, 10s, 100s, 1000s, etc.
'-----------------------------------------------------------------------------

DIM dblNumber(10) AS DOUBLE

    FOR intIndex = intLength TO 1 STEP -1
        dblNumber(intIndex) = ASC(MID$(strSource, intLength - intIndex + 1, 1)) - 48
    NEXT intIndex

'-----------------------------------------------------------------------------
'   Multiply individual numbers by 1, 10, 100, 1000, etc.
'-----------------------------------------------------------------------------

      dblNumber(1) = dblNumber(1) * 1
      dblNumber(2) = dblNumber(2) * 10
      dblNumber(3) = dblNumber(3) * 100
      dblNumber(4) = dblNumber(4) * 1000
      dblNumber(5) = dblNumber(5) * 10000
      dblNumber(6) = dblNumber(6) * 100000
      dblNumber(7) = dblNumber(7) * 1000000
      dblNumber(8) = dblNumber(8) * 10000000
      dblNumber(9) = dblNumber(9) * 100000000
    dblNumber(10) = dblNumber(10) * 1000000000

'-----------------------------------------------------------------------------
'   Add up all of the individual numbers and place result in dblResult
'-----------------------------------------------------------------------------

DIM dblResult AS DOUBLE

    FOR intIndex = intLength TO 1 STEP -1
        dblResult = dblResult + dblNumber(intIndex)
    NEXT intIndex


'-----------------------------------------------------------------------------
'   identify immediate data-type: long or unsigned long
'-----------------------------------------------------------------------------

    SELECT CASE dblResult

        CASE -2147483648# TO 2147483647#
             is.long = cstImmediateLong
             EXIT FUNCTION

    END SELECT


END FUNCTION

'#############################################################################
'#                                                                           #
'#############################################################################
FUNCTION is.procedure (strSource AS STRING)
   
    SELECT CASE label.find(strSource)

        CASE cstProcedureFunction
             is.procedure = cstProcedureFunction

        CASE cstProcedureSub
             is.procedure = cstProcedureSub
       
        CASE ELSE
             is.procedure = cstFALSE
             
    END SELECT

END FUNCTION

FUNCTION is.string (strSource AS STRING)
   
    DIM intLength AS INTEGER

        intLength = LEN(strSource)
            IF intLength = 0 THEN
                is.string = cstFALSE
                EXIT FUNCTION
            END IF

    IF LEFT$(strSource, 1) = CHR$(34) THEN
        IF RIGHT$(strSource, 1) = CHR$(34) THEN
            is.string = cstImmediateString
        END IF
    END IF

END FUNCTION

'#############################################################################
'#                                                                           #
'#############################################################################
FUNCTION is.variable (strSource AS STRING)

DIM intIndex AS INTEGER
    intIndex = label.find(strSource)

    SELECT CASE intIndex
   
        CASE cstVariableByte
        CASE cstVariableDouble
        CASE cstVariableInteger
        CASE cstVariableLong
        CASE cstVariableSingle
        CASE cstVariableString
       
        CASE ELSE
           is.variable = cstFALSE
           EXIT FUNCTION

    END SELECT

    is.variable = intIndex

END FUNCTION

