DEFINT A-Z

CONST cstTRUE = -1, cstFALSE = 0

'$INCLUDE: 'asm.bi'
'$INCLUDE: 'const.bi'
'$INCLUDE: 'is.bi'
'$INCLUDE: 'keyword.bi'
'$INCLUDE: 'label.bi'
'$INCLUDE: 'string.bi'
'$INCLUDE: 'token.bi'

DECLARE SUB keyword.declare.fn ()

'#############################################################################
'# Routine is complete.                                             v.0.1.00 #
'#############################################################################
SUB keyword.asm (intIndex AS INTEGER)

DIM strTemp AS STRING

    strTemp = tkn.item(intIndex + 1)

    SELECT CASE is.immediate(strTemp)

        CASE cstImmediateString
             asm.code MID$(strTemp, 2, LEN(strTemp) - 2)

        CASE ELSE
             keyword.error "ERROR: Expected string."
             END

    END SELECT

END SUB

'#############################################################################
'# This keyword is complete.                                        v.0.1.00 #
'#############################################################################
SUB keyword.dec (intIndex AS INTEGER)
    
DIM strTemp AS STRING
    strTemp = tkn.item(intIndex + 1)

        IF is.variable(strTemp) = cstFALSE THEN
           IF is.alpha.numeric(strTemp) = cstTRUE THEN
              keyword.error "Variable must be declared first."
              END
           ELSE
              keyword.error "Expected variable"
              END
           END IF
        END IF
                 
asm.code strTemp

END SUB

'#############################################################################
'#                                                                           #
'#############################################################################
SUB keyword.declare (intIndex AS INTEGER)
DIM strTemp AS STRING
    strTemp = tkn.item(intIndex + 1)

    SELECT CASE LCASE$(strTemp)

        CASE "function"
             keyword.declare.fn
       
        CASE "sub"
        '    keyword.declare.sub

    END SELECT

END SUB

'#############################################################################
'#                                                                           #
'#############################################################################
SUB keyword.declare.fn

DIM strTemp    AS STRING
DIM strFunc    AS STRING
DIM intFunc    AS INTEGER
DIM strParam   AS STRING
DIM intParam   AS INTEGER
DIM intIterate AS INTEGER
DIM intFlag    AS INTEGER

'#############################################################################
'#                                                                           #
'#############################################################################
    strTemp = tkn.item(intIndex + 2)

        IF is.alpha.numeric(strTemp) = cstFALSE THEN
           keyword.error "Expected, alpha-numeric identifier"
           END
        ELSE
           strFunc = LCASE$(strTemp)
        END IF

'#############################################################################
'#                                                                           #
'#############################################################################
    strTemp = tkn.item(intIndex + 3)

        IF strTemp <> "(" THEN
           keyword.error "Expected, left parenthese"
           END
        END IF

'#############################################################################
'#                                                                           #
'#############################################################################
    intIterate = intIndex + 4

        DO

'#############################################################################
'#                                                                           #
'#############################################################################
            strTemp = LCASE$(tkn.item(intIterate))
           
            IF strTemp = ")" THEN
               intIterate = intIterate + 1
               strParam = "0"
               intParam = 0
               EXIT DO
            END IF

               IF is.alpha.numeric(strTemp) = cstFALSE THEN
                  keyword.error "Expected, alpha-numeric identifer."
                  END
               ELSE
                  intIterate = intIterate + 1
               END IF

'#############################################################################
'#                                                                           #
'#############################################################################
            strTemp = LCASE$(tkn.item(intIterate))
               SELECT CASE strTemp

                   CASE "as"
                        intIterate = intIterate + 1

                   CASE "("
                        keyword.error "Error, arrays not implimented in this version."
                        END
                  
                   CASE ELSE
                        keyword.error "Error, expected keyword:  AS"
                        END

               END SELECT
          
'#############################################################################
'#                                                                           #
'#############################################################################
            strTemp = LCASE$(tkn.item(intIterate))
              
               SELECT CASE strTemp
               
                   CASE "byte"
                        strParam = strParam + string.trim(STR$(cstVariableByte)) + "|"
                  
                   CASE "double"
                        strParam = strParam + string.trim(STR$(cstVariableDouble)) + "|"
                  
                   CASE "integer"
                        strParam = strParam + string.trim(STR$(cstVariableInteger)) + "|"
                  
                   CASE "long"
                        strParam = strParam + string.trim(STR$(cstVariableLong)) + "|"
                  
                   CASE "single"
                        strParam = strParam + string.trim(STR$(cstVariableSingle)) + "|"
                  
                   CASE "string"
                        strParam = strParam + string.trim(STR$(cstVariableString)) + "|"

                   CASE "unsigned"
                        keyword.error "Error, Unsigned data-type not implimented in this version."
                        END
                  
                   CASE ELSE
                        keyword.error "Expected data-type."
                        END

                END SELECT

'#############################################################################            
'#                                                                           #
'#############################################################################

            intParam = intParam + 1
            intIterate = intIterate + 1
            strTemp = LCASE$(tkn.item(intIterate))

'#############################################################################
'#                                                                           #
'#############################################################################
                SELECT CASE strTemp
               
                   CASE ","
                        intFlag = cstTRUE

                   CASE ")"
                        intFlag = cstFALSE

                   CASE ELSE
                        keyword.error "Expected, comma or right parenthese."
                        END

                END SELECT

'#############################################################################
'#                                                                           #
'#############################################################################

            SELECT CASE intFlag

                CASE cstTRUE
                     intIterate = intIterate + 1

                CASE cstFALSE
                     intIterate = intIterate + 1
                     EXIT DO

            END SELECT

        LOOP

'#############################################################################
'#                                                                           #
'#############################################################################
    strTemp = LCASE$(tkn.item(intIterate))
      
        SELECT CASE strTemp
                   
            CASE "as"
                 intIterate = intIterate + 1

            CASE ELSE
                 keyword.error "Error, expected keyword:  AS"
                 END

        END SELECT

'#############################################################################
'#                                                                           #
'#############################################################################
    strTemp = LCASE$(tkn.item(intIterate))
       
        SELECT CASE strTemp
           
            CASE "byte"
                 intFunc = cstVariableByte
           
            CASE "double"
                 intFunc = cstVariableDouble
           
            CASE "integer"
                 intFunc = cstVariableInteger
           
            CASE "long"
                 intFunc = cstVariableLong
           
            CASE "single"
                 intFunc = cstVariableSingle
           
            CASE "string"
                 intFunc = cstVariableString

            CASE "unsigned"
                 keyword.error "Error, Unsigned data-type not implimented in this version."
                 END

            CASE ELSE
                 keyword.error "Expected data-type."
                 END

        END SELECT

'#############################################################################
'#                                                                           #
'#############################################################################

    strFunc = strFunc + STR$(intParam) + "|" + strParam + STR$(intFunc)
    label.add strFunc, cstProcedureFunction

END SUB

'#############################################################################
'#                                                                           #
'#############################################################################
SUB keyword.dim (intIndex AS INTEGER)

DIM strTemp     AS STRING
DIM strVariable AS STRING

    strTemp = tkn.item(intIndex + 1)

    SELECT CASE LCASE$(strTemp)

        CASE "shared"
             keyword.dim.shared intIndex + 1
             EXIT SUB

'#############################################################################
'# Room for future upgrades possible DIM [XMS|EMS] variable[(subscripts)]... #
'#############################################################################

    END SELECT

    
       IF is.alpha.numeric(strTemp) = cstTRUE THEN

          strVariable = strTemp

       ELSE
          keyword.error "Expected variable"
          END
       END IF
    
    strTemp = tkn.item(intIndex + 2)

    SELECT CASE LCASE$(strTemp)

        CASE "as"
        CASE "("
             keyword.dim.array intIndex + 3, cstScopeLocal, strVariable
             EXIT SUB

        CASE ELSE
             keyword.error "Expected keyword AS"
             END
        
    END SELECT

    strTemp = tkn.item(intIndex + 3)

    SELECT CASE LCASE$(strTemp)

        CASE "byte"
             label.add strVariable, cstVariableByte
             asm.data strVariable + " sbyte 0"

        CASE "double"
             label.add strVariable, cstVariableDouble
             asm.data strVariable + " real8 0.0"

        CASE "integer"
             label.add strVariable, cstVariableInteger
             asm.data strVariable + " sword 0"

        CASE "long"
             label.add strVariable, cstVariableLong
             asm.data strVariable + " slong 0"
        
        CASE "single"
             label.add strVariable, cstVariableSingle
             asm.data strVariable + " real4 0.0"

        CASE "string"
             label.add strVariable, cstVariableString

             IF tkn.count = (intIndex + 3) THEN
                asm.data strVariable + " byte 255 dup(?)"
             ELSE
                IF tkn.item(intIndex + 4) = "*" THEN
                asm.data strVariable + " byte " + tkn.item(intIndex + 5) + " dup (?)"
                END IF
             END IF

        CASE "unsigned"
             keyword.error "Error, Unsigned data-type not implimented in this version."
             END

        CASE ELSE
             keyword.error "Expected data-type."
             END

    END SELECT

END SUB

'#############################################################################
'#                                                                           #
'#############################################################################
SUB keyword.dim.array (intIndex AS INTEGER, intScope AS INTEGER, strVariable AS STRING)

    keyword.error "Error, arrays not implimented in this version."
    END

END SUB

'#############################################################################
'#                                                                           #
'#############################################################################
SUB keyword.dim.shared (intIndex AS INTEGER)

    keyword.error "DIM SHARED not implimented in this version."
    END

'DIM strTemp AS STRING
'    strTemp = tkn.item(intIndex + 2)

END SUB

'#############################################################################
'#                                                                           #
'#############################################################################
SUB keyword.error (strSource AS STRING)
   
    PRINT strSource
    PRINT tkn.line.index

END SUB

'#############################################################################
'#                                                                           #
'#############################################################################
SUB keyword.parse (intIndex AS INTEGER)

    SELECT CASE LCASE$(tkn.item(intIndex))

        CASE "asm"
             keyword.asm intIndex

        CASE "call"
        CASE "case"
        CASE "const"
        CASE "dec"
             keyword.dec intIndex

        CASE "declare"
             keyword.declare intIndex

        CASE "dim"
             keyword.dim intIndex

        CASE "do"
        CASE "else"
        CASE "end"
        CASE "exit"
        CASE "for"
        CASE "function"
        CASE "goto"
        CASE "if"
        CASE "inc"
        CASE "let"
        CASE "loop"
        CASE "next"
        CASE "return"
        CASE "select"
        CASE "sub"
        CASE "type"
        CASE ELSE
       
    END SELECT

END SUB

