DEFINT A-Z

CONST cstTRUE = -1, cstFALSE = 0

'$INCLUDE: 'label.bi'
'$INCLUDE: 'is.bi'
'$INCLUDE: 'string.bi'
'$INCLUDE: 'const.bi'

TYPE labelType

    strSource AS STRING * 30
    intType   AS INTEGER

END TYPE

DIM SHARED udtLabel(1 TO 1024)  AS labelType
DIM SHARED strSharedParams(255) AS STRING
DIM SHARED intSharedNextLabel   AS INTEGER

'#############################################################################
'#                                                                           #
'#############################################################################
SUB label.add (strSource AS STRING, intType AS INTEGER)

DIM intIndex AS INTEGER
DIM strParam AS STRING

  SELECT CASE intType

    CASE cstProcedureFunction, cstProcedureSub
         intIndex = INSTR(1, strSource, " ")
         strParam = MID$(strSource, intIndex + 1, LEN(strSource) - intIndex)
         strSource = LEFT$(strSource, intIndex - 1)

  END SELECT

    SELECT CASE is.procedure(strSource)

        CASE cstProcedureFunction
             label.error "Error, identifier already declared as a FUNCTION"
             END

        CASE cstProcedureSub
             label.error "Error, identifier already declared as a SUB."
             END

        CASE ELSE
    END SELECT

    SELECT CASE is.variable(strSource)
        CASE cstVariableByte
             label.error "Error, identifier already declared as a Byte."
             END
       
        CASE cstVariableDouble
             label.error "Error, identifier already declared as a Double."
             END
       
        CASE cstVariableInteger
             label.error "Error, identifier already declared as an Integer."
             END

        CASE cstVariableLong
             label.error "Error, identifier already declared as a Long."
             END
       
        CASE cstVariableSingle
             label.error "Error, identifier already declared as a Single."
             END

        CASE cstVariableString
             label.error "Error, identifier already declared as a String."
             END

        CASE ELSE
    END SELECT
   
    intSharedNextLabel = intSharedNextLabel + 1

    udtLabel(intSharedNextLabel).strSource = strSource
   
    IF intType = cstProcedureFunction THEN
       strSharedParams(intSharedNextLabel) = strParam
    END IF

    udtLabel(intSharedNextLabel).intType = intType
    

END SUB

'#############################################################################
'#                                                                           #
'#############################################################################
SUB label.error (strSource AS STRING)

    PRINT strSource
    PRINT tkn.line.index

END SUB

'#############################################################################
'# Returns cstFALSE if label not found, otherwise label.find returns 1..1024 #
'#############################################################################
FUNCTION label.find (strSource AS STRING)

DIM intIndex AS INTEGER
DIM strTemp AS STRING

    FOR intIndex = 1 TO intSharedNextLabel
        strTemp = string.trim(udtLabel(intIndex).strSource)
        strTemp = LCASE$(strTemp)
       
            IF strTemp = LCASE$(strSource) THEN
                label.find = udtLabel(intIndex).intType
                EXIT FUNCTION
            END IF

    NEXT intIndex

    label.find = cstFALSE

END FUNCTION

FUNCTION label.param$ (strSource AS STRING)

DIM intIndex AS INTEGER
DIM strTemp AS STRING

    FOR intIndex = 1 TO intSharedNextLabel
        strTemp = string.trim(udtLabel(intIndex).strSource)
        strTemp = LCASE$(strTemp)
      
            IF strTemp = LCASE$(strSource) THEN
               EXIT FOR
            END IF

    NEXT intIndex

    label.param = strSharedParams(intIndex)

END FUNCTION

