DEFINT A-Z

CONST cstTRUE = -1, cstFalse = 0

'$INCLUDE: 'asm.bi'
'$INCLUDE: 'expr.bi'
'$INCLUDE: 'is.bi'
'$INCLUDE: 'string.bi'
'$INCLUDE: 'token.bi'

DECLARE SUB main (strCommandLine AS STRING)
DECLARE SUB main.error (strSource AS STRING)
DECLARE SUB main.parse (strSource AS STRING)
DECLARE SUB keyword.parse (intIndex AS INTEGER)


CLS
   
    main COMMAND$

END

'#############################################################################
'#                                                                           #
'#############################################################################
SUB main (strCommandLine AS STRING)

    asm.head ".model medium, basic"
    asm.head ".stack 0ffh"
    asm.head ".386"
    asm.data CHR$(13) + ".data" + CHR$(13)
    asm.code CHR$(13) + ".code" + CHR$(13)

  
        main.parse "Declare Function lngAdd(int1 as integer, int2 as integer) As long"
         tkn.clear
        main.parse "dim lngResult As Long"
         tkn.clear
        main.parse "lngResult = lngAdd(6, 6)"
         tkn.clear

    
    asm.foot CHR$(13) + "lbl_Signed_Overflow:" + CHR$(13)
    asm.foot CHR$(13) + "end" + CHR$(13)

    OPEN "c:\qb45\temp.asm" FOR OUTPUT AS #1
    PRINT #1, asm.file
    PRINT asm.file
    CLOSE #1
    

END SUB

'#############################################################################
'#                                                                           #
'#############################################################################
SUB main.error (strSource AS STRING)

    PRINT strSource
    PRINT tkn.line.index

END SUB

'#############################################################################
'#                                                                           #
'#                                                                           #
'#                                                                           #
'#############################################################################
SUB main.parse (strSource AS STRING)
    STATIC intAssemblyFlag AS INTEGER

    DIM intLength    AS INTEGER
    DIM intIterate   AS INTEGER
    DIM intIndex     AS INTEGER
    DIM intMaxTokens AS INTEGER

        strSource = string.trim(strSource)
        intLength = LEN(strSource)

'#############################################################################
'# Check for END ASM directive.                                              #
'#############################################################################
    IF intAssemblyFlag = cstTRUE THEN
       intIndex = INSTR(1, LCASE$(strSource), "end asm")

       IF intIndex = 0 THEN
          asm.code strSource
          EXIT SUB
       ELSE
          intAssemblyFlag = cstFalse
          EXIT SUB
       END IF

    END IF

'#############################################################################
'# Check for ASM directive.                                                  #
'#############################################################################
    IF intAssemblyFlag = cstFalse THEN
       IF intLength = 3 THEN
          intIndex = INSTR(1, LCASE$(strSource), "asm")

             IF intIndex <> 0 THEN
                intAssemblyFlag = cstTRUE
                EXIT SUB
             END IF

       END IF
    END IF

'#############################################################################
'# Check for INCLUDE directive.                                              #
'#############################################################################
    intIndex = INSTR(1, LCASE$(strSource), "include")

    IF intIndex <> 0 THEN
       main.error "INCLUDE directive not implimented in this version."
       END
    END IF

'#############################################################################
'# Code parser                                                               #
'#############################################################################

    tkn.tokenizer strSource
    intMaxTokens = tkn.count

        FOR intIndex = 0 TO intMaxTokens
           
            IF is.keyword(tkn.item(intIndex)) = cstTRUE THEN
               keyword.parse intIndex
               EXIT FOR     'Assume entire source line was taken care of,
                            'this will reduce coding problems later.
            END IF

            IF is.variable(tkn.item(intIndex)) <> cstFalse THEN
                expr.parse intIndex
                EXIT FOR    'Assume as above
            END IF

        NEXT intIndex


END SUB

