DEFINT A-Z

CONST cstTrue = -1, cstFalse = 0

'$INCLUDE: 'token.bi'

'#############################################################################
'#                                                                           #
'#############################################################################
SUB tkn.add (strSource AS STRING)

DIM intLen   AS INTEGER
DIM intIndex AS INTEGER

'#############################################################################

    strSource = LTRIM$(RTRIM$(strSource))
    intLen = LEN(strSource)

'#############################################################################
   
    IF intLen = 0 THEN
       EXIT SUB
    END IF
    
    IF intLen > 40 THEN
       tkn.error "Identifier too long"
       END
    END IF

'#############################################################################

    intIndex = tkn.index

        IF intIndex > 255 THEN
           tkn.error "Too many tokens"
        END IF

'#############################################################################

    strSharedTokens(intIndex) = strSource

'#############################################################################
   
    tkn.inc

END SUB

'#############################################################################
'#                                                                           #
'#############################################################################
SUB tkn.clear

'#############################################################################

    ERASE strSharedTokens
    intSharedTokenIndex = 0
   
'#############################################################################

END SUB

'#############################################################################
'#                                                                           #
'#############################################################################
FUNCTION tkn.count

'#############################################################################

    tkn.count = intSharedTokenIndex - 1

'#############################################################################

END FUNCTION

'#############################################################################
'#                                                                           #
'#############################################################################
SUB tkn.error (strSource AS STRING)

'#############################################################################
   
    PRINT strSource
    PRINT lngSharedLineNumber

'#############################################################################

END SUB

'#############################################################################
'#                                                                           #
'#############################################################################
SUB tkn.inc

'#############################################################################

    intSharedTokenIndex = intSharedTokenIndex + 1
    
'#############################################################################

END SUB

'#############################################################################
'#                                                                           #
'#############################################################################
FUNCTION tkn.index

'#############################################################################

    tkn.index = intSharedTokenIndex

'#############################################################################

END FUNCTION

'#############################################################################
'#                                                                           #
'#############################################################################
FUNCTION tkn.item$ (intIndex AS INTEGER)

'#############################################################################
   
    IF intIndex < 0 THEN
       tkn.item$ = ""
       EXIT FUNCTION
    END IF

    IF intIndex > intSharedTokenIndex THEN
       tkn.item$ = ""
       EXIT FUNCTION
    END IF

'#############################################################################

        tkn.item$ = strSharedTokens(intIndex)

'#############################################################################

END FUNCTION

'#############################################################################
'#                                                                           #
'#############################################################################
SUB tkn.line.inc

'#############################################################################

    lngSharedLineNumber = lngSharedLineNumber + 1

'#############################################################################

END SUB

'#############################################################################
'#                                                                           #
'#############################################################################
FUNCTION tkn.line.index&

'#############################################################################

    tkn.line.index& = lngSharedLineNumber

'#############################################################################

END FUNCTION

'#############################################################################
'#                                                                           #
'#############################################################################
SUB tkn.tokenizer (strSource AS STRING)

DIM intLen     AS INTEGER
DIM intIndex   AS INTEGER
DIM intIterate AS INTEGER
DIM strChar    AS STRING
DIM strTemp    AS STRING

'#############################################################################
   
    strSource = strSource + " "
    intLen = LEN(strSource)

    IF intLen = 1 THEN
       EXIT SUB
    END IF

'#############################################################################

    tkn.line.inc

'#############################################################################

    FOR intIndex = 1 TO intLen
        strChar = MID$(strSource, intIndex, 1)

            SELECT CASE strChar

                CASE "a" TO "z", "A" TO "Z", "0" TO "9", "_", "."
                     strTemp = strTemp + strChar
                    
                CASE CHR$(9), CHR$(10), CHR$(13), CHR$(32)
                     tkn.add strTemp
                     strTemp = ""

                CASE CHR$(34)
                     tkn.add strTemp
                     strTemp = CHR$(34)
                     intIndex = intIndex + 1

                     FOR intIterate = intIndex TO intLen
                         strChar = MID$(strSource, intIterate, 1)

                         SELECT CASE strChar

                            CASE CHR$(34)
                                 strTemp = strTemp + strChar
                                 tkn.add strTemp
                                 strTemp = ""
                                 intFlag = cstTrue
                                 
                            CASE ELSE
                                 strTemp = strTemp + strChar

                         END SELECT

                     NEXT intIterate
                    
                     intIndex = intIterate + 1
                     IF intFlag = cstFalse THEN
                        tkn.error "Mismatched quotation markes."
                        END
                     END IF
                     
                CASE CHR$(39)
               
                CASE ELSE
                     tkn.add strTemp
                     tkn.add strChar
                     strTemp = ""
           
            END SELECT
       
    NEXT intIndex

'#############################################################################

END SUB

